// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#include <shared_mutex>
#include "source.h"

typedef struct
{
	uint8_t *data;
	size_t len;
	uint64_t ts;
	int width, height;
} h_data_t;

class source_delay : public source
{
private:
	std::vector<h_data_t> frames;
	std::shared_mutex frames_lock;

	source *const s;
	const int jpeg_quality;
	const size_t n_frames;
	const double max_fps;

	uint8_t *prev_frame{ nullptr };

public:
	source_delay(const std::string & id, const std::string & descr, const std::string & exec_failure, source *const s, const int jpeg_quality, const int n_frames, const double max_fps, resize *const r, const int resize_w, const int resize_h, const int ll, const double timeout, std::vector<filter *> *const filters);
	virtual ~source_delay();

	bool get_frame(const encoding_t pe, const int jpeg_quality, uint64_t *ts, int *width, int *height, uint8_t **frame, size_t *frame_len, const bool repeat) override;
	uint64_t get_current_ts() override;

	virtual void operator()() override;
};
